unit PluginMain;

interface

uses
  Windows,
  AviUtlPlugin;

function GetFilterTable: PFILTER_DLL; stdcall;
function func_init(fp: PFILTER): BOOL; cdecl;
function func_exit(fp: PFILTER): BOOL; cdecl;
function func_proc(fp: PFILTER; fpip: PFILTER_PROC_INFO): BOOL; cdecl;
function func_update(fp:pFILTER; status:longint):BOOL; cdecl;

const
  TRACK_N = 5;
  track_name: array[0..4] of PChar = ('Kp(+)','Kp(-)','͈','U','臒l');
  track_default: array[0..4] of Integer = (25, 50, 10, 50, 0);
  track_s: array[0..4] of Integer = (0, 0, 1, 0, 0);
  track_e: array[0..4] of Integer = (300, 300, 100,100,1000);

  FilterInfo: FILTER_DLL = (
    flag: FILTER_FLAG_EX_INFORMATION;
    x: 0;
    y: 0;
    name: 'KEVAEAV[v}XN';
    track_n: TRACK_N;
    track_name: @track_name[0];
    track_default: @track_default[0];
    track_s: @track_s[0];
    track_e: @track_e[0];
    check_n: 0;
    check_name: nil;
    check_default: nil;
    func_proc: func_proc;
    func_init: func_init;
    func_exit: func_exit;
    func_update: func_update;
    func_WndProc: nil;
    track: nil;
    check: nil;
    ex_data_ptr: nil;
    ex_data_size: 0;
    information: 'KEVAEAV[v}XN Ver.091112';
    func_save_start: nil;
    func_save_end: nil;
  );

implementation

uses
  UnsharpMask, Math;

function GetFilterTable: PFILTER_DLL; stdcall;
begin
  Result :=@FilterInfo;
end;

function func_init(fp: PFILTER): BOOL; cdecl;
var
  SInfo: TSystemInfo;
  MaxThread: UINT;
begin
  GetSystemInfo(SInfo);
  if SInfo.dwNumberOfProcessors > 8 then MaxThread := SInfo.dwNumberOfProcessors
  else MaxThread := 8;
  USM := TUnsharpMaskFilter.Create(MaxThread);
  Result := True;
end;

function func_exit(fp: PFILTER): BOOL; cdecl;
begin
  USM.Free;
  USM := nil;
  Result := True;
end;

function func_update(fp:pFILTER; status:longint):BOOL; cdecl;
begin
  USM.SetBlurParam(fp.track[2] / 10 + 0.5, Power(10, fp.track[3]/32));
  USM.SetThreshold(fp.track[4]);
  USM.SetStrength(fp.track[0] * 4096 div 100, fp.track[1] * 4096 div 100);
  Result := True;
end;

procedure HorizontalMTProc(thread_id:longint; thread_num:longint; param1:pointer; param2:pointer);cdecl;
var
  fpip: PFILTER_PROC_INFO;
begin
  fpip := param1;
  USM.HFilter(fpip.ycp_temp, fpip.ycp_edit, thread_id, thread_num);
end;

procedure VerticalMTProc(thread_id:longint; thread_num:longint; param1:pointer; param2:pointer);cdecl;
var
  fpip: PFILTER_PROC_INFO;
begin
  fpip := param1;
  USM.VFilter(fpip.ycp_edit, fpip.ycp_temp, thread_id, thread_num);
end;

function func_proc(fp: PFILTER; fpip: PFILTER_PROC_INFO): BOOL; cdecl;
begin
  Result := True;
  USM.SetFilterParam(fpip.w, fpip.h, fpip.max_w);
  fp.exfunc.exec_multi_thread_func(HorizontalMTProc, fpip, nil);
  fp.exfunc.exec_multi_thread_func(VerticalMTProc, fpip, nil);
end;

end.
