
%include "alignmacro.inc"

section CONST align=16 public use32
align 16
i128_pdw_8192:
    dd  $2000, $2000, $2000, $2000

threshold:
    dw  0, 0, 0, 0, 0, 0, 0, 0

strength:
    dw  0, 0, 0, 0, 0, 0, 0, 0


section _TEXT align 16 public use32 class=CODE

align 16
global _setthreshold

_setthreshold:
    movd        xmm0, [esp+4]
    punpcklwd   xmm0, xmm0
    pshufd      xmm0, xmm0, 0
    movdqu      [threshold], xmm0
    ret

align 16
global _setstrength

_setstrength:
    movd        xmm0, [esp+8]
    movd        xmm1, [esp+4]
    punpcklwd   xmm0, xmm1
    pshufd      xmm0, xmm0, 0
    movdqu      [strength], xmm0
    ret

%define dest [ebp+8]
%define src [ebp+12]
%define weighttable [ebp+16]
%define work [ebp+20]
%define bloopcount [ebp+24]
%define xloopcount [ebp+28]
%define yloopcount [ebp+32]
%define destbpl [ebp+36]
%define srcbpl [ebp+40]

align 16
global _luma_hfilter

_luma_hfilter:
    push        ebp
    mov         ebp, esp
    push        edi
    push        esi
    push        ebx
    mov         edi, dest
    mov         esi, src
    movdqu      xmm7, [i128_pdw_8192]

alignx 4
.nextline:
    mov         ebx, srcbpl
    mov         edx, work
    mov         ecx, bloopcount
    lea         eax, [ebx+ebx*2]

alignx 4
.next4x4pixel:
    pinsrw      xmm0, [esi], 0
    pinsrw      xmm1, [esi+12], 0
    pinsrw      xmm0, [esi+6], 1
    pinsrw      xmm1, [esi+18], 1
    pinsrw      xmm0, [esi+ebx], 2
    pinsrw      xmm1, [esi+ebx+12], 2
    pinsrw      xmm0, [esi+ebx+6], 3
    pinsrw      xmm1, [esi+ebx+18], 3
    pinsrw      xmm0, [esi+ebx*2], 4
    pinsrw      xmm1, [esi+ebx*2+12], 4
    pinsrw      xmm0, [esi+ebx*2+6], 5
    pinsrw      xmm1, [esi+ebx*2+18], 5
    pinsrw      xmm0, [esi+eax], 6
    pinsrw      xmm1, [esi+eax+12], 6
    pinsrw      xmm0, [esi+eax+6], 7
    pinsrw      xmm1, [esi+eax+18], 7
    movdqa      [edx], xmm0
    movdqa      [edx+16], xmm1
    add         edx, 32
    add         esi, 24
    dec         ecx
    jnz         .next4x4pixel
    mov         ecx, xloopcount
    mov         eax, weighttable
    mov         ebx, destbpl

alignx 4
.nextpixel:
    push        ecx
    pxor        xmm0, xmm0
    pxor        xmm1, xmm1
    mov         esi, work
    mov         edx, [eax+4]
    add         esi, [eax]
    mov         ecx, [edx-4]
    add         eax, 8
    dec         ecx
    jz          .next2tap

alignx 4
.next4tap:
    movq        xmm2, [edx]
    pshufd      xmm3, xmm2, 0x55
    pshufd      xmm2, xmm2, 0
    movdqa      xmm4, [esi]
    movdqa      xmm5, [esi+16]
    pmaddwd     xmm4, xmm2
    pmaddwd     xmm5, xmm3
    paddd       xmm0, xmm4
    paddd       xmm1, xmm5
    add         edx, 8
    add         esi, 32
    sub         ecx, 2
    jnle        .next4tap
    paddd       xmm0, xmm1
    jnz         .next2tap_end

.next2tap:
    movd        xmm2, [edx]
    pshufd      xmm2, xmm2, 0
    movdqa      xmm3, [esi]
    pmaddwd     xmm3, xmm2
    paddd       xmm0, xmm3

.next2tap_end:
    paddd       xmm0, xmm7
    psrad       xmm0, 14
    packssdw    xmm0, xmm0
    movd        [edi], xmm0
    pop         ecx
    psrlq       xmm0, 32
    dec         ecx
    movd        [edi+ebx*2], xmm0
    add         edi, 4
    test        ecx, ecx
    jnz         .nextpixel

    mov         esi, src
    mov         edi, dest
    mov         eax, srcbpl
    mov         ecx, yloopcount
    lea         esi, [esi+eax*4]
    lea         edi, [edi+ebx*4]
    dec         ecx
    mov         src, esi
    mov         dest, edi
    mov         yloopcount, ecx
    test        ecx, ecx
    jnz         .nextline
    pop         ebx
    pop         esi
    pop         edi
    mov         esp, ebp
    pop         ebp
    ret

;
;void unsharpmask_vfilter(void* dest, void* src, void* weighttable, uint32 xloopcount, uint32 yloopcount, uint32 destbpl, uint32 srcbpl)
;
align 16
global _unsharpmask_vfilter

_unsharpmask_vfilter:

%define dest [ebp+8]
%define src [ebp+12]
%define weighttable [ebp+16]
%define xloopcount [ebp+20]
%define yloopcount [ebp+24]
%define destbpl [ebp+28]
%define srcbpl [ebp+32]

    push        ebp
    mov         ebp, esp
    push        edi
    push        esi
    push        ebx
    mov         edi, dest
    mov         eax, weighttable
    movdqu      xmm5, [threshold]
    movdqu      xmm6, [strength]
    movdqu      xmm7, [i128_pdw_8192]
    mov         ebx, srcbpl
    shl         ebx, 1

alignx 4
.nextline:
    mov         esi, src
    mov         ecx, xloopcount
    add         esi, [eax]

alignx 4
.nextdata:
    push        ecx
    push        esi
    pxor        xmm0, xmm0
    pxor        xmm1, xmm1
    mov         edx, [eax+4]
    mov         ecx, [edx-4]

alignx 4
.next2tap:
    movd        xmm3, [edx]
    pshufd      xmm2, xmm3, 0
    movdqa      xmm3, xmm2
    pmaddwd     xmm2, [esi]
    pmaddwd     xmm3, [esi+16]
    paddd       xmm0, xmm2
    paddd       xmm1, xmm3
    add         edx, 4
    add         esi, ebx
    dec         ecx
    jnz         .next2tap
    paddd       xmm0, xmm7
    paddd       xmm1, xmm7
    psrad       xmm0, 14
    psrad       xmm1, 14
    packssdw    xmm0, xmm1
    pinsrw      xmm2, [edi], 0
    pinsrw      xmm2, [edi+6], 1
    pinsrw      xmm2, [edi+12], 2
    pinsrw      xmm2, [edi+18], 3
    pinsrw      xmm2, [edi+24], 4
    pinsrw      xmm2, [edi+30], 5
    pinsrw      xmm2, [edi+36], 6
    pinsrw      xmm2, [edi+42], 7
    movdqa      xmm4, xmm5
    psubw       xmm0, xmm2
    movdqa      xmm1, xmm0
    psraw       xmm0, 15
    pxor        xmm1, xmm0
    psubusw     xmm4, xmm1
    psubusw     xmm1, xmm4
    pxor        xmm1, xmm0
    movdqa      xmm3, xmm0
    pandn       xmm0, xmm1
    pand        xmm3, xmm1
    movdqa      xmm1, xmm0
    punpcklwd   xmm0, xmm3
    punpckhwd   xmm1, xmm3
    pmaddwd     xmm0, xmm6
    pmaddwd     xmm1, xmm6
    psrad       xmm0, 12
    psrad       xmm1, 12
    packssdw    xmm0, xmm1
    paddw       xmm2, xmm0
    pextrw      ecx, xmm2, 0
    pextrw      edx, xmm2, 1
    mov         [edi], cx
    mov         [edi+6], dx
    pextrw      ecx, xmm2, 2
    pextrw      edx, xmm2, 3
    mov         [edi+12], cx
    mov         [edi+18], dx
    pextrw      ecx, xmm2, 4
    pextrw      edx, xmm2, 5
    mov         [edi+24], cx
    mov         [edi+30], dx
    pextrw      ecx, xmm2, 6
    pextrw      edx, xmm2, 7
    mov         [edi+36], cx
    mov         [edi+42], dx
    pop         esi
    pop         ecx
    add         edi, 48
    add         esi, 32
    dec         ecx
    jnz         .nextdata
    mov         eax, weighttable
    mov         ecx, yloopcount
    mov         edi, dest
    add         eax, 8
    dec         ecx
    add         edi, destbpl
    mov         weighttable, eax
    mov         yloopcount, ecx
    mov         dest, edi
    test        ecx, ecx
    jnz         .nextline
    pop         ebx
    pop         esi
    pop         edi
    mov         esp, ebp
    pop         ebp
    ret

